#include <iostream>
#include "windows.h"
#include "KeyboardHook.h"

using namespace std;


BOOL APIENTRY DllMain( HANDLE hModule, DWORD  dwReason, LPVOID lpReserved)
{
	switch (dwReason)
	{
	case DLL_PROCESS_ATTACH:
		g_Module = (HINSTANCE)hModule; // Save Dll Handle
		break; 
	case DLL_PROCESS_DETACH:
		StopHook();
		g_Module = NULL;
		break;
	}
	return TRUE;
}


bool StartHook(HOOKPROC proc)
{
	if(hKeyboardHook != NULL) { return false; }

	g_callback = proc;
	hKeyboardHook = SetWindowsHookEx(WH_KEYBOARD_LL, KeyboardProc, g_Module, 0);
	return (hKeyboardHook != NULL);
}



bool StopHook()
{
	if(hKeyboardHook == NULL) { return false; }

	if(UnhookWindowsHookEx(hKeyboardHook) == TRUE) { //
		hKeyboardHook = NULL;
	}
	return (hKeyboardHook == NULL);
}


LRESULT CALLBACK KeyboardProc(int nCode, WPARAM wParam, LPARAM lParam)
{ 
	
	if(hKeyboardHook != NULL) {
		// -1  ϵǸ NextHook ȣ 
		if(g_callback(nCode, wParam, lParam) == -1) {
			return -1;
		}
	}
	return ::CallNextHookEx(hKeyboardHook, nCode, wParam, lParam); 
}